package com.csc.library.command.common;

import com.csc.library.command.CommandRecord;
import com.csc.library.command.util.CommonParameterUtil;
import com.csc.library.request.CommandState;
import com.csc.library.request.CommonModeParameter;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.MyLog;

/* save record */
public class Command002 extends CommandRecord<CommonModeParameter>{

	@Override
	public void execute(CommonModeParameter param) throws Exception {
		try{
			DbRecord rec = new InitialRecord(this.getUProfile()).getDbRecord(param.getTableName());
			if(param.getGroupField().equals("")){
				
			}else{
				rec.setGroupfield(param.getGroupField());
			}
			
			CommonParameterUtil.setKeyRecord(rec, param);
			if(rec.search() == 0){
				CommonParameterUtil.setJsonRecord(rec, param);
				CommonParameterUtil.setKeyRecord(rec, param);
				int saveStatus = rec.save();
				if(saveStatus == 1){
					this.sendMessage("Command002 : Save Record Success" , CommandState.success);
					this.setRecord(rec);
				}else{
					this.sendMessage("Command002 : Save Record Fail" , CommandState.fail);
				}
			}else{
				this.sendMessage("Command002 : Save Record Fail because Data Record is found data in database." , CommandState.fail);
			}
		}catch(Exception e){
			MyLog.error(this ,this.getUProfile(), e);
			this.sendMessage(e.getMessage());
		}
	}
	
}
