package com.csc.library.command.common;

import com.csc.library.command.CommandNoResult;
import com.csc.library.command.CommandRecord;
import com.csc.library.command.util.CommonParameterUtil;
import com.csc.library.request.CommandState;
import com.csc.library.request.CommonModeParameter;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.MyLog;

/* Update Record */
public class Command004 extends CommandNoResult<CommonModeParameter>{

	@Override
	public void execute(CommonModeParameter param) throws Exception {
		try{
			DbRecord rec = new InitialRecord(this.getUProfile()).getDbRecord(param.getTableName());
			CommonParameterUtil.setKeyRecord(rec, param);
			if(rec.search()== 1){
				CommonParameterUtil.setJsonRecord(rec, param);
				CommonParameterUtil.setKeyRecord(rec, param);
				int updateStatus = rec.save();
				if(updateStatus == 2){
					this.sendMessage("Command004 : Update Record Success" , CommandState.success);
				}else{
					this.sendMessage("Command004 : Update Record Fail" , CommandState.fail);
				}
			}else{
				this.sendMessage("Command004 : Update Record Fail because Data Record not found data in database." , CommandState.fail);
			}
		}catch(Exception e){
			MyLog.error(this , this.getUProfile() , e);
		}
	}
}
