package com.csc.library.command.common;

import java.util.Vector;

import com.csc.library.command.CommandRecord;
import com.csc.library.command.util.CommonParameterUtil;
import com.csc.library.database.FieldManager;
import com.csc.library.request.CommandState;
import com.csc.library.request.CommonModeParameter;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.MyLog;
/* Read Json Record */
public class Command005 extends CommandRecord<CommonModeParameter>{

	@Override
	public void execute(CommonModeParameter param) throws Exception {
		try{
			DbRecord rec = new InitialRecord(this.getUProfile()).getDbRecord(param.getTableName());
			rec.setColumn(param.getJsonField());
			CommonParameterUtil.setKeyRecord(rec, param);
			
			FieldManager fm = rec.getField(param.getJsonField());
			String jsontable = (String)fm.getProperty().get("jsonrecord");
			
			DbRecord recJson = new InitialRecord(this.getUProfile()).getDbRecord(jsontable);
			String filter = CommonParameterUtil.getFilterKeyRecord(recJson, param);

			rec.setJsonTable(param.getJsonField() , filter);
			DbTable dt = rec.getJsonTable(param.getJsonField());

			if(dt.recCount()>0){
				dt.first();
				for(;!dt.eof();dt.next()){
					this.setRecord(dt.getCurrentRecordManager());
					this.sendMessage("Command005 : Search Json Data is Found.", CommandState.success);
				}
			}else{
				this.sendMessage("Command005 : Search Json Data is not Found.", CommandState.fail);
			}

		}catch(Exception e){
			MyLog.error(this , this.getUProfile() ,e);
		}
	}

}
