package com.csc.library.command.common;

import java.util.Vector;

import com.csc.library.command.CommandNoResult;
import com.csc.library.command.util.CommonParameterUtil;
import com.csc.library.database.FieldManager;
import com.csc.library.request.CommandState;
import com.csc.library.request.CommonModeParameter;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.MyLog;

/* Delete Json Record */
public class Command007  extends CommandNoResult<CommonModeParameter>{

	@Override
	public void execute(CommonModeParameter param) throws Exception {
		try{
			DbRecord rec = new InitialRecord(this.getUProfile()).getDbRecord(param.getTableName());
			rec.setColumn(param.getJsonField());
			CommonParameterUtil.setKeyRecord(rec, param);
			
			FieldManager fm = rec.getField(param.getJsonField());
			String jsontable = (String)fm.getProperty().get("jsonrecord");
			
			DbRecord recJson = new InitialRecord(this.getUProfile()).getDbRecord(jsontable);
			Vector allKey = recJson.getAllKey();
			StringBuilder filter = new StringBuilder("1=1");
			for(int i = 0; i < allKey.size(); i++){
				String key = allKey.get(i).toString();
				if(param.getJsonKey().containsKey(key)){
					filter.append(" and ").append(key).append("='").append(param.getJsonKey().get(key)).append("'");
				}
			}
			rec.setJsonTable(param.getJsonField() , filter.toString());
			DbTable dt = rec.getJsonTable(param.getJsonField());

			if(dt.recCount() == 1){
				int deleteStatus = dt.getCurrentRecordManager().delete();
				if(deleteStatus == 4){
					this.sendMessage("Command007 : Delete Json Record Success.", CommandState.success);
				}else{
					this.sendMessage("Command007 : Delete Json Record Fail.", CommandState.fail);
				}
			}else{
				this.sendMessage("Command007 : Search Json Record is not Found. cannot Delete Json Record", CommandState.fail);
			}
		}catch(Exception e){
			MyLog.error(this ,this.getUProfile() , e);
		}
	}

}
