package com.csc.library.factory;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.csc.library.properties.CscSession;
import com.csc.library.properties.HandlePackage;
import com.csc.library.properties.ResponsePools;
import com.csc.library.request.CommandState;
import com.csc.library.request.RequestWebsocket;
import com.csc.library.response.ResponseData;
import com.csc.library.response.ResponsePropertiesImpl;
import com.csc.library.response.ResponseStatus;
import com.csc.library.response.ResponseWebsocket;
import com.csc.library.utilities.MyLog;

public class ResponseFactory {
	private static ResponseFactory instance;
	//private Map<CscSession,List<ResponseWebsocket>> response = new HashMap<CscSession ,List<ResponseWebsocket>>();
	private ResponsePools<ResponsePropertiesImpl> response;
	private PropertiesFactory propInstance;
	private HandlePackage handle;
	
	private ResponseFactory(){
	}
	
	public static ResponseFactory getInstance(){
		if(instance == null){
			instance = new ResponseFactory();
			instance.propInstance = PropertiesFactory.getInstance();
			instance.response = ResponsePools.getInstance();
			instance.handle = HandlePackageFactory.getInstance().getHandlePackage();
		}
		return instance;
	}
	
	public void sendResponseWebsocket(CscSession session , RequestWebsocket req ,CommandState stateComm,ResponseStatus stateRes, String message){
		ResponsePropertiesImpl res = this.getResponseWebsocket(session);
		res.setRequestWebsocket(req);
		res.setMessage(message);
		res.setResponseStatus(stateRes);
		res.setStateCommand(stateComm);
		this.sendResponse(session, res);
	}
	
	public void sendResponseWebsocket(CscSession session , RequestWebsocket req ,CommandState stateComm,ResponseData resData, String message){
		ResponsePropertiesImpl res = this.getResponseWebsocket(session);
		res.setRequestWebsocket(req);
		res.setMessage(message);
		res.setResponseStatus(ResponseStatus.Finish);
		res.setResponseData(resData);
		res.setStateCommand(stateComm);
		this.sendResponse(session, res);
	}
	
	protected ResponsePropertiesImpl getResponseWebsocket(CscSession session){
		ResponsePropertiesImpl res = null;
		try{
			res = this.response.pop();
			if(res == null){
				res = new ResponsePropertiesImpl(); 
			}
		}catch(Exception e){
			MyLog.error(this , session.getUProfile() , e);
		}
		return res;
	}
	
	protected void sendResponse(CscSession session , ResponseWebsocket res){
		PackageDataFactory.getInstance().sendData(session, this.handle, res);
		res.clear();
		this.response.push((ResponsePropertiesImpl)res);
	}
}
