package com.csc.library.modecontroller;

import java.io.File;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.jdom.Element;

import com.csc.library.command.CscCommand;
import com.csc.library.fix.StaticVariable;
import com.csc.library.request.CMDMode;
import com.csc.library.request.RequestParameter;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReadXml;

public class ManageSpecialMode extends AbsModeManagement{
	private Map<String,Map<String,String>> map = new HashMap<String,Map<String,String>>();
	private final CMDMode mode = CMDMode.special;
	@Override
	public void execute(CscCommand command, RequestParameter reqParam) throws Exception {
		command.execute(reqParam.getSpecialParameter());
	}

	@Override
	public void load(String path) {
		try{
			File fileDir = new File(path + mode.toString());
			if(fileDir.isDirectory()){
				File[] listFile = fileDir.listFiles();
				for(File f : listFile){
					ReadXml rm = new ReadXml( f.getPath() , false);
					Element eRoot = rm.getRootElement();
					Map<String,String> hm = new HashMap<String,String>();
					hm.put(StaticVariable.CommandSpecialAttribute.CLASSNAME, mode.toString()+".CommandSpecialBase");
					List childs = eRoot.getChildren();
					for( int i = 0 ; i < childs.size() ; i++ ){
						Element child = (Element)childs.get(i);
						hm.put(child.getName().toLowerCase() , child.getText());
					}
					this.map.put(eRoot.getName() , Collections.unmodifiableMap(hm));
				}
			}
		}catch(Exception ex){
			MyLog.error(this , ex);
		}
	}

	@Override
	public String getClassName(String code) {
		if(this.map.containsKey(code)){
			return this.map.get(code).get(StaticVariable.CommandSpecialAttribute.CLASSNAME);
		}else{
			return "";
		}
	}

	@Override
	public Map<String, String> getParamConfig(String code) {
		return this.map.get(code);
	}

}
