package com.csc.library.properties;

import java.io.IOException;

import javax.websocket.Session;

import com.csc.library.factory.PackageDataFactory;
import com.csc.library.response.ResponseWebsocket;
import com.csc.library.utilities.UProfile;

public class SessionHandle implements CscSession{
	private CscDevice device = null;
	private Session session = null;
	private UProfile uprofile = null;
	
	public SessionHandle(UProfile upf , Session session , CscDevice device) {
		this.uprofile = upf;
		this.session = session;
		this.device = device;
	}
	
	@Override
	public CscDevice getDevice() {
		// TODO Auto-generated method stub
		return device;
	}
	@Override
	public UProfile getUProfile() {
		// TODO Auto-generated method stub
		return uprofile;
	}
	
	public void sendMessage(String message){
		if(!this.isAlive()){
			return;
		}
		try {
			this.session.getBasicRemote().sendText(message);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public boolean isAlive(){
		return this.session.isOpen();
	}
}
