package com.csc.library.task;

import com.csc.library.command.CscCommand;
import com.csc.library.factory.CMDModeFactory;
import com.csc.library.factory.ResponseDataFactory;
import com.csc.library.factory.ResponseFactory;
import com.csc.library.properties.CscSession;
import com.csc.library.request.CommandState;
import com.csc.library.request.RequestWebsocket;
import com.csc.library.response.ResponseStatus;
import com.csc.library.utilities.MyLog;

public class TaskCommand implements CommandTask{
	private CscSession session;
	private RequestWebsocket request;
	private CscCommand command;
	
	public TaskCommand(){
	}
	
	public TaskCommand(CscSession session, RequestWebsocket req , CscCommand command) {
		this.session = session;
		this.request = req;
		this.command = command;
	}
	
	public RequestWebsocket getRequest(){
		return this.request;
	}
	
	public CscSession getSession(){
		return this.session;
	}
	
	public CscCommand getCommand(){
		return this.command;
	}
	
	public void run() {
		try {
			CMDModeFactory.getInstance().getModeCtrl(this.getRequest().getCommandMode())
				.execute(this.getCommand(), this.getRequest().getRequestParameter());
			
			ResponseFactory.getInstance().sendResponseWebsocket(
					this.getSession(), 
					this.getRequest(), 
					this.getCommand().getCommandState(),
					ResponseDataFactory.getInstance().createResponseData(this.getCommand()), 
					"");
		} catch (Exception e) {
			MyLog.error(this , this.getSession().getUProfile(), e);
			ResponseFactory.getInstance().sendResponseWebsocket(
					this.getSession(), 
					this.getRequest(), 
					CommandState.fail,
					ResponseStatus.Error, 
					e.getMessage());
		}
	}
}
